import { parseOData } from "./utils";
var Auth = /** @class */ (function () {
    function Auth(ctx) {
        this.ctx = ctx;
    }
    Auth.prototype.ensureRequestDigest = function (digest) {
        return digest ? Promise.resolve(digest) : this.getRequestDigest();
    };
    /** Get a Request Digest token to authorize a request */
    Auth.prototype.getRequestDigest = function () {
        return this.ctx._post("/contextInfo", {}).then(function (data) { return data.FormDigestValue; });
    };
    Auth.prototype.getGraphToken = function () {
        var endpoint = "/SP.OAuth.Token/Acquire";
        return this.ctx._post(endpoint, { resource: "https://graph.microsoft.com" }).then(parseOData);
    };
    return Auth;
}());
export default Auth;
