var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { parseOData } from "./utils";
var CustomActions = /** @class */ (function () {
    function CustomActions(ctx) {
        var _this = this;
        this._getUrl = function (name) { return __awaiter(_this, void 0, void 0, function () {
            var target;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get(name)];
                    case 1:
                        target = _a.sent();
                        if (!target || !target["odata.editLink"]) {
                            throw new Error("Unable to find matching Custom Action: " + name);
                        }
                        return [2 /*return*/, "/" + target["odata.editLink"]];
                }
            });
        }); };
        this.activateExtension = function (title, componentId, properties, overrides) {
            if (properties === void 0) { properties = {}; }
            if (overrides === void 0) { overrides = {}; }
            var customAction = __assign({ Name: title, ClientSideComponentId: componentId, Location: "ClientSideExtension.ApplicationCustomizer", ClientSideComponentProperties: JSON.stringify(properties) }, overrides);
            return _this.add(customAction);
        };
        this.ctx = ctx;
    }
    CustomActions.prototype.get = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var webCustomActions, siteCustomActions, allCustomActions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ctx.get("/web/usercustomactions").then(parseOData)];
                    case 1:
                        webCustomActions = _a.sent();
                        return [4 /*yield*/, this.ctx.get("/site/usercustomactions").then(parseOData)];
                    case 2:
                        siteCustomActions = _a.sent();
                        allCustomActions = __spreadArrays(webCustomActions, siteCustomActions);
                        if (name) {
                            return [2 /*return*/, allCustomActions.find(function (c) { return c.Name === name; })];
                        }
                        return [2 /*return*/, allCustomActions];
                }
            });
        });
    };
    /** Update an existing Custom Action. You must pass a custom action with a 'Name' property */
    CustomActions.prototype.update = function (updates) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!updates || !updates.Name)
                            throw new Error("You must at least pass a Custom Action 'Name'");
                        return [4 /*yield*/, this._getUrl(updates.Name)];
                    case 1:
                        url = _a.sent();
                        return [2 /*return*/, this.ctx.post(url, updates, "MERGE")];
                }
            });
        });
    };
    /** Remove an existing Custom Action. Searches both Site and Web scoped */
    CustomActions.prototype.remove = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!name)
                            throw new Error("You must at least pass an existing Custom Action name");
                        return [4 /*yield*/, this._getUrl(name)];
                    case 1:
                        url = _a.sent();
                        return [2 /*return*/, this.ctx.post(url, {}, "DELETE")];
                }
            });
        });
    };
    /** Adds a new custom action. If the custom action name already exists, it will be deleted first */
    CustomActions.prototype.add = function (customAction) {
        return __awaiter(this, void 0, void 0, function () {
            var defaults, exists, url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!customAction || !customAction.Name)
                            throw new Error("You must at least pass a Custom Action 'Name'");
                        defaults = {
                            Name: customAction.Name,
                            Title: customAction.Name,
                            Description: customAction.Name,
                            // Group: customAction.Name,
                            Sequence: 100,
                            Scope: 2,
                        };
                        customAction = __assign(__assign({}, defaults), customAction);
                        return [4 /*yield*/, this.get(customAction.Name)];
                    case 1:
                        exists = _a.sent();
                        if (!exists) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.remove(customAction.Name)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        url = (customAction.Scope === 2 ? "/site" : "/web") + "/usercustomactions";
                        return [2 /*return*/, this.ctx.post(url, customAction)];
                }
            });
        });
    };
    return CustomActions;
}());
export default CustomActions;
