import Context from "./Context";
export default class MMS {
    private ctx;
    constructor(ctx: Context);
    getTermset: (termGroup: string, termset: string) => Promise<MMSTerm[]>;
    getTermTree: (termGroup: string, termset: string) => Promise<MMSTermTree>;
}
export interface MMSTerm {
    id: string;
    sortOrder: number;
    description: string;
    name: string;
    path: string;
    termSetName: string;
    properties: {
        [key: string]: string;
    };
    children: MMSTerm[];
}
export interface MMSTermTree extends MMSTerm {
    flatTerms: MMSTerm[];
    getTermByName(termName: string): MMSTerm;
    getTermById(termGuid: string): MMSTerm;
    getTermByPath(path: string): MMSTerm;
}
export declare const toTermTree: (flatTerms: MMSTerm[]) => MMSTermTree;
export declare const getTermSet: (termGroupName: string, termSetName: string, ctx: Context) => Promise<MMSTerm[]>;
