var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var MMS = /** @class */ (function () {
    function MMS(ctx) {
        var _this = this;
        this.getTermset = function (termGroup, termset) {
            return getTermSet(termGroup, termset, _this.ctx);
        };
        this.getTermTree = function (termGroup, termset) { return __awaiter(_this, void 0, void 0, function () {
            var flatTerms;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, getTermSet(termGroup, termset, this.ctx)];
                    case 1:
                        flatTerms = _a.sent();
                        return [2 /*return*/, toTermTree(flatTerms)];
                }
            });
        }); };
        this.ctx = ctx;
    }
    return MMS;
}());
export default MMS;
export var toTermTree = function (flatTerms) {
    try {
        var tree_1 = _toTermTree(flatTerms);
        var termTree = __assign(__assign({ flatTerms: flatTerms }, tree_1), { getTermById: function (termGuid) {
                return findInTree(tree_1, function (term) { return term.id === termGuid; });
            },
            getTermByName: function (termName) {
                // console.log("getTermByName -> tree", tree);
                return findInTree(tree_1, function (term) { return term.name === termName; });
            },
            getTermByPath: function (path) {
                var targetPath = normalizeSlashes(path.toLowerCase());
                // console.log("GETBYPATH", path, this.children);
                return findInTree(tree_1, function (term) { return term.path.toLowerCase() === targetPath; });
            } });
        return termTree;
    }
    catch (err) {
        console.log("ERROR!!!! parsing term groupd", err);
        return null;
    }
};
export var getTermSet = function (termGroupName, termSetName, ctx) { return __awaiter(void 0, void 0, void 0, function () {
    var flatTerms;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, _getTermsetTerms(termGroupName, termSetName, ctx)];
            case 1:
                flatTerms = _a.sent();
                // console.log("TCL: flatTerms", flatTerms);
                return [2 /*return*/, sortByPath(flatTerms)];
        }
    });
}); };
var _toTermTree = function (flatTerms) {
    var sortedTerms = sortByPath(flatTerms);
    // console.log("TCL: groupByPath -> sortedTerms", sortedTerms);
    // Requires a presort by path
    // Assumes the path parts match the 'name' property
    var result = sortedTerms.reduce(function (results, term) {
        var pathParts = term.path.split("/");
        var scope = results;
        // console.log("_toTermTree -> pathParts", pathParts);
        pathParts.forEach(function (key) {
            var match = scope.find(function (t) { return t.name === key; });
            if (!match) {
                scope.push(term);
                scope = term.children;
            }
            else {
                // console.log("_toTermTree -> match", key, match);
                scope = match.children;
            }
        });
        return results;
    }, []);
    // console.log("TCL: result", result);
    return result.length === 1 ? result[0] : result;
};
var sortByPath = function (terms) {
    return terms.sort(function (a, b) {
        if (a.path === b.path)
            return 0;
        return a.path < b.path ? -1 : 1;
    });
};
var findInTree = function (term, findFn) {
    if (findFn(term))
        return term;
    // console.log("term.name", term);
    // console.log("term.children.length", term.children.length);
    for (var i = 0; i < term.children.length; i++) {
        var childMatch = findInTree(term.children[i], findFn);
        if (childMatch)
            return childMatch;
    }
    return null;
};
var processTerm = function (term, termSetName) {
    return {
        id: cleanGuid(term.Id),
        sortOrder: term.CustomSortOrder || 9999,
        children: [],
        description: term.Description,
        name: term.Name.replace(/\//g, "|"),
        path: (termSetName + ";" + term.PathOfTerm).replace(/\//g, "|").split(";").join("/"),
        properties: __assign(__assign({}, term.CustomProperties), term.LocalCustomProperties),
        termSetName: termSetName,
    };
};
function cleanGuid(guid) {
    return guid ? guid.replace("/Guid(", "").replace("/", "").replace(")", "") : "";
}
var normalizeSlashes = function (str) {
    try {
        if (!str)
            return "";
        if (str[0] === "/") {
            str = str.substring(1);
        }
        if (str[str.length - 1] === "/") {
            str = str.substring(0, str.length - 1);
        }
        return str;
    }
    catch (err) {
        return "";
    }
};
var _getTermsetTerms = function (termGroup, termset, ctx) { return __awaiter(void 0, void 0, void 0, function () {
    var digest, url, headers, data, tc;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, ctx.auth.getRequestDigest()];
            case 1:
                digest = _a.sent();
                url = ctx.webUrl + "/_vti_bin/client.svc/ProcessQuery?";
                headers = __assign(__assign({}, ctx.headers), { "content-type": "text/xml", "x-requestdigest": digest });
                return [4 /*yield*/, fetch(url, {
                        method: "POST",
                        body: getRequestXml(termGroup, termset),
                        headers: headers,
                    }).then(function (resp) { return resp.json(); })];
            case 2:
                data = _a.sent();
                tc = data.find(function (d) { return d._ObjectType_ === "SP.Taxonomy.TermCollection"; });
                if (tc && tc._Child_Items_) {
                    return [2 /*return*/, __spreadArrays([
                            createTermFromTermsetName(termset)
                        ], tc._Child_Items_.map(function (t) { return processTerm(t, termset); }))];
                }
                return [2 /*return*/, []];
        }
    });
}); };
var createTermFromTermsetName = function (termset) {
    return {
        id: "root",
        sortOrder: 1,
        children: [],
        description: termset,
        name: termset,
        path: termset,
        properties: {},
        termSetName: termset,
    };
};
var getRequestXml = function (termGroup, termset) {
    return "<Request xmlns=\"http://schemas.microsoft.com/sharepoint/clientquery/2009\" SchemaVersion=\"15.0.0.0\" LibraryVersion=\"16.0.0.0\" ApplicationName=\"PnPjs\">\n  <Actions>\n      <Query Id=\"1\" ObjectPathId=\"6\">\n          <Query SelectAllProperties=\"true\">\n              <Properties />\n          </Query >\n          <ChildItemQuery SelectAllProperties=\"false\">\n              <Properties>\n                  <Property Name=\"Id\" SelectAll=\"true\" />\n                  <Property Name=\"CustomSortOrder\" SelectAll=\"true\" />\n                  <Property Name=\"Description\" SelectAll=\"true\" />\n                  <Property Name=\"Name\" SelectAll=\"true\" />\n                  <Property Name=\"PathOfTerm\" SelectAll=\"true\" />\n                  <Property Name=\"LocalCustomProperties\" SelectAll=\"true\" />\n                  <Property Name=\"CustomProperties\" SelectAll=\"true\" />\n              </Properties>\n          </ChildItemQuery >\n      </Query >\n  </Actions>\n  <ObjectPaths>\n      <StaticMethod Id=\"0\" Name=\"GetTaxonomySession\" TypeId=\"{981cbc68-9edc-4f8d-872f-71146fcbb84f}\" />\n      \n      <Method Id=\"1\" ParentId=\"0\" Name=\"GetDefaultSiteCollectionTermStore\"></Method>\n      <Property Id=\"2\" ParentId=\"1\" Name=\"Groups\" />\n      <Method Id=\"3\" ParentId=\"2\" Name=\"GetByName\">\n          <Parameters>\n              <Parameter Type=\"String\">" + termGroup + "</Parameter>\n          </Parameters>\n      </Method>\n      <Property Id=\"4\" ParentId=\"3\" Name=\"TermSets\" />\n      <Method Id=\"5\" ParentId=\"4\" Name=\"GetByName\">\n          <Parameters>\n              <Parameter Type=\"String\">" + termset + "</Parameter>\n          </Parameters>\n      </Method>\n      <Method Id=\"6\" ParentId=\"5\" Name=\"GetAllTerms\"></Method>\n  </ObjectPaths>\n</Request>";
};
