import Context from "./Context";
export interface QueryOptions {
    sourceid?: string;
    startrow?: number;
    rowlimit?: number;
    selectproperties?: string;
    refiners?: string;
    refinementfilters?: string;
    hiddencontstraints?: any;
    sortlist?: any;
}
export interface Refiner {
    RefinerName: string;
    RefinerOptions: any[];
}
export interface SearchResultResponse {
    elapsedTime: string;
    suggestion: any;
    resultsCount: number;
    totalResults: number;
    totalResultsIncludingDuplicates: number;
    /** The actual search results that you care about */
    items: any[];
    refiners?: Refiner[];
}
export default class Search {
    private _dao;
    constructor(ctx: Context);
    /** get default/empty QueryOptions */
    get defaultQueryOptions(): QueryOptions;
    /** Query the SP Search Service */
    query(queryTemplate: string, queryOptions?: QueryOptions): Promise<SearchResultResponse>;
    /** Query for only People results */
    people(queryText: string, queryOptions?: QueryOptions): Promise<SearchResultResponse>;
    /** Query for only sites (STS_Web). Optionally pass in a url scope. */
    sites(queryText?: string, urlScope?: string, queryOptions?: QueryOptions): Promise<SearchResultResponse>;
}
