import Context from "./Context";
/** Allows you to check the permissions of a securable (list or site) */
export default class Securable {
    private _dao;
    private baseUrl;
    constructor(baseUrl: string, ctx: Context);
    /** Gets all the role assignments on that securable  */
    getRoleAssignments(): Promise<RoleAssignment[]>;
    private checkPrivs;
    /** Gets all the role assignments on that securable. If you don't pass an email, it will use the current user. */
    check(email?: string): Promise<string[]>;
}
export interface BasePermission {
    name: string;
    low: number;
    high: number;
}
export interface RoleMember {
    login: string;
    name: string;
    id: string;
    principalType: number;
}
export interface RoleDef {
    /** Role definition name */
    name: string;
    description: string;
    /** An array of base permission names */
    basePermissions: string[];
}
export interface RoleAssignment {
    /** User or Group */
    member: RoleMember;
    /** An array of role definitions */
    roles: RoleDef[];
}
export declare var basePermissions: BasePermission[];
