import * as allUtils from "./utils";
import { isBrowser, getSiteUrl } from "./utils";
import Context from "./Context";
export function createContext(url, options) {
    try {
        if (isBrowser())
            if (!url && window._spPageContextInfo) {
                // TODO: use get Site url util
                url = window._spPageContextInfo.webAbsoluteUrl;
            }
        if (!url)
            url = getSiteUrl();
        if (!url)
            throw new Error("Unable to find url to create SPScript Context");
        return new Context(url, options);
    }
    catch (ex) {
        throw new Error("Unable to create SPScript Context: " + ex.message);
    }
}
export var utils = allUtils;
export default {
    createContext: createContext,
    utils: allUtils,
};
