var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var jsonMimeType = "application/json";
/** returns a Headers object with 'Accept', 'Content-Type' and optional 'X-RequestDigest' */
export function getStandardHeaders(digest) {
    var headers = {
        Accept: jsonMimeType,
        "Content-Type": jsonMimeType,
    };
    if (digest)
        headers["X-RequestDigest"] = digest;
    return headers;
}
/** returns a Headers object with values configured for binary stream*/
export var getFilestreamHeaders = function (digest) {
    return {
        Accept: jsonMimeType,
        "X-RequestDigest": digest,
        "Content-Type": "application/octet-stream",
        binaryStringRequestBody: "true",
    };
};
/** returns a Headers object with including the X-HTTP-Method with the specified verb */
export var getActionHeaders = function (verb, digest) {
    var headers = getStandardHeaders(digest);
    if (verb) {
        headers = __assign(__assign({}, headers), {
            "X-HTTP-Method": verb,
            "If-Match": "*",
        });
    }
    return headers;
};
/** returns a Headers object with values configured ADDING an item */
export var getAddHeaders = getStandardHeaders;
/** returns a Headers object with values configured UPDATING an item */
export var getUpdateHeaders = function (digest) { return getActionHeaders("MERGE", digest); };
/** returns a Headers object with values configured DELETING an item */
export var getDeleteHeaders = function (digest) { return getActionHeaders("DELETE", digest); };
